// subclass Table

import java.io.*;
import java.util.*;

class Table {

    private static final int MaxRow = 200;		// MaxRow is the maximum items in the data_table.
    private static final int MaxColumn = 10;	// MaxColumn is the maximum distributs of an item.

    private static final double Delta = 0.00001;// Using by comparing in real numbers.

    String itemName[] = new String[MaxRow];	            // item names

//    double item[][] = new double[MaxRow][MaxColumn];	// database
    String item[][] = new String[MaxRow][MaxColumn];	// database
    double grade[][] = new double[MaxRow][MaxColumn+1];	// database
    
    String filter[] = new String[MaxColumn];               // condition
//    double filterParameter[] = new double[MaxColumn];             // compared value
    String filterParameter[] = new String[MaxColumn];             // compared value

    String ranker[] = new String[MaxColumn];               // condition
//    double rankerParameter[] = new double[MaxColumn];             // compared value
    String rankerParameter[] = new String[MaxColumn];             // compared value

    double weight[] = new double[MaxColumn];             // compared value

    int next[] = new int[MaxRow];		                  // ranking list

    int row, column, top;
    
    public Table()
    {
    }

    public int loadData(String str) throws IOException{
        StringTokenizer matrix = new StringTokenizer(str, "\n");
        row = matrix.countTokens();
        column = 0;
        for (int i_row = 0; i_row < row; i_row++) {
            itemName[i_row] = matrix.nextToken();
            StringTokenizer line = new StringTokenizer(itemName[i_row], " \t");
            if (column <= 0)
                column = line.countTokens();
 //           line.nextToken();
            for (int i_column = 0; i_column < column; i_column++)
//                item[i_row][i_column] = Double.valueOf(line.nextToken()).doubleValue();
                item[i_row][i_column] = line.nextToken();
        }
        return (row*10000 + column);
    }
            
    public void applyFilter(String str) throws IOException{
        StringTokenizer inData = new StringTokenizer(str);
        for (int i_column = 0; i_column < column; i_column++) {
            filter[i_column] = inData.nextToken();
            if (!(filter[i_column].equals("*")))
//	            filterParameter[i_column] = Double.valueOf(inData.nextToken()).doubleValue();
	            filterParameter[i_column] = inData.nextToken();
        }
        runFilter();
    }
    
    private void runFilter() throws IOException{
        int i_row, i_column;
        for (i_row = 0; i_row < row; i_row++) 
	        grade[i_row][column] = 0;
        for (i_row = 0; i_row < row; i_row++) 
            for (i_column = 0; i_column < column; i_column++)
                if (grade[i_row][column] >= 0)
                    filt(i_row, i_column);
    }

    private void filt(int i_r, int i_c) throws IOException {
        if (filter[i_c].equals("*")) 
            return;
        if (filter[i_c].equals("=")) {
//            if (abs(item[i_r][i_c] - filterParameter[i_c]) > Delta)
//            if (!(item[i_r][i_c].equals(filterParameter[i_c])))
            if (!(diff(item[i_r][i_c], filterParameter[i_c]) == 0.0))
                grade[i_r][column] = -1;
            return;
        }
        if (filter[i_c].equals("!=")) {
//            if (abs(item[i_r][i_c] - filterParameter[i_c]) < Delta)
//            if (item[i_r][i_c].equals(filterParameter[i_c]))
            if (diff(item[i_r][i_c], filterParameter[i_c]) == 0.0)
                grade[i_r][column] = -1;
            return;
        }
        if (filter[i_c].equals(">=")) {
//            if (Double.valueOf(item[i_r][i_c]).doubleValue() < Double.valueOf(filterParameter[i_c]).doubleValue())
            if (diff(item[i_r][i_c], filterParameter[i_c]) < 0)
                grade[i_r][column] = -1;
            return;
        }
        if (filter[i_c].equals("<=")) {
//            if (Double.valueOf(item[i_r][i_c]).doubleValue() > Double.valueOf(filterParameter[i_c]).doubleValue())
            if (diff(item[i_r][i_c], filterParameter[i_c]) > 0)
                grade[i_r][column] = -1;
            return;
        }
        if (filter[i_c].equals(">")) {
//            if (Double.valueOf(item[i_r][i_c]).doubleValue() <= Double.valueOf(filterParameter[i_c]).doubleValue())
            if (diff(item[i_r][i_c], filterParameter[i_c]) <= 0)
                grade[i_r][column] = -1;
            return;
        }
        if (filter[i_c].equals("<")) {
//            if (Double.valueOf(item[i_r][i_c]).doubleValue() >= Double.valueOf(filterParameter[i_c]).doubleValue())
            if (diff(item[i_r][i_c], filterParameter[i_c]) >= 0)
                grade[i_r][column] = -1;
            return;
        }
    }


    public void applyRanker(String str) throws IOException{
        StringTokenizer inData = new StringTokenizer(str);
        int i_row, i_column;
        for (i_column = 0; i_column < column; i_column++) {
            ranker[i_column] = inData.nextToken();
            if ((ranker[i_column].equals("=~"))||(ranker[i_column].equals("~~")))
	            rankerParameter[i_column] = inData.nextToken();
        }
        runRanker();
    }
    
    private void runRanker() throws IOException{
       for (int i_row = 0; i_row < row; i_row++) 
            if (grade[i_row][column] >= 0)
                for (int i_column = 0; i_column < column; i_column++)
                    membership(i_row, i_column);
    }
	
    private void membership (int i_r, int i_c) throws IOException {
		double w_d, w_p, w_t, self, other, param;
        if (ranker[i_c].equals("*")) {
	        grade[i_r][i_c] = -1;
            return;
        }
//        self = Double.valueOf(item[i_r][i_c]).doubleValue();
		w_p = 0;
		w_t = 0;
		for (int i_row = 0; i_row < row; i_row++) {
		    if (grade[i_row][column] >= 0) {
//		        other = Double.valueOf(item[i_row][i_c]).doubleValue();
			    if (ranker[i_c].equals(">~"))
//      			    w_d = self - other;
                    w_d = diff(item[i_r][i_c], item[i_row][i_c]);
			    else if (ranker[i_c].equals("<~"))
//				    w_d = other - self;
                    w_d = diff(item[i_row][i_c], item[i_r][i_c]);
			    else if (ranker[i_c].equals("=~")) {
//                    param = Double.valueOf(rankerParameter[i_c]).doubleValue();
//      			    w_d = abs(other - param) - abs(self - param);
                    w_d = abs(diff(item[i_row][i_c], rankerParameter[i_c]))
                        - abs(diff(item[i_r][i_c], rankerParameter[i_c]));
 			    } else if (ranker[i_c].equals("~~"))
//      			    w_d = self - other;
                    w_d = diff(item[i_r][i_c], item[i_row][i_c]);
        	    else {
                    grade[i_r][i_c] = -1;
     	            return;
     	        }
			    if (w_d > Delta) {
      			    w_p += w_d;
				    w_t += w_d;
			    }
			    else if (w_d < - Delta)
      			    w_t -= w_d;
      		}
		}
		if (w_t > 0)
		    if (ranker[i_c].equals("~~"))
		        grade[i_r][i_c] = 1 - abs((w_p / w_t) - Double.valueOf(rankerParameter[i_c]).doubleValue());
		    else
   			    grade[i_r][i_c] = (w_p / w_t);
		else
   			grade[i_r][i_c] = -1;
	}

    private double diff (String s1, String s2) throws IOException {
//        if (s1.equals(s2))
//            return 0.0;
        double v1 = Double.valueOf(s1).doubleValue();
        double v2 = Double.valueOf(s2).doubleValue();
        return v1-v2;
    }
    
    public void applyWeight(String str) throws IOException{
        StringTokenizer inData = new StringTokenizer(str);
        for (int i_column = 0; i_column < column; i_column++)
            weight[i_column] =  Double.valueOf(inData.nextToken()).doubleValue();
        getTotal();
    }
    
    private void getTotal() throws IOException{
        double total, obtained;
        for (int i_row = 0; i_row < row; i_row++) 
            if (grade[i_row][column] >= 0) {
                total = 0.0;
                obtained = 0.0;
                for (int i_column = 0; i_column < column; i_column++)
                    if (grade[i_row][i_column] >= 0) {
	                    total += weight[i_column];
	                    obtained += grade[i_row][i_column] * weight[i_column];
                    }
                if (total > Delta)
                    grade[i_row][column] = obtained / total;
                else
                    grade[i_row][column] = 1;
            }
    }


    public String showTop(String str) throws IOException {
 	    StringBuffer buf = new StringBuffer();
        int i_row, best_i, score;
        double best_v;
        top = Integer.valueOf(str).intValue();
        if (top > row)
            top = row;
        for (i_row=0; i_row<row; i_row++)
            next[i_row] = 0;
        for (int i_top = 0; i_top < top; i_top++) {
            best_v = -1.0;
            best_i = -1;
            for (i_row=0; i_row<row; i_row++)
                if ((grade[i_row][column] > best_v) && (next[i_row] == 0)) {
                    best_v = grade[i_row][column];
                    best_i = i_row;
                }
            if (best_i >= 0) {
                next[best_i] = 1;
                score = (int) (100 * grade[best_i][column]);
                if (score < 100)
                    buf.append(" ");
                if (score < 10)
                    buf.append("  ");            
                buf.append(score);
                buf.append("%      ");
                buf.append(itemName[best_i]);
                buf.append("\n");
            }
        }
        return buf.toString();
    }


    private double abs(double v){
        if (v > 0)
   	        return v;
        else
   	        return -v;
    }
}

